diff -cprN head/src/backend/catalog/dependency.c work/src/backend/catalog/dependency.c
*** head/src/backend/catalog/dependency.c	2010-01-04 09:10:26.638773000 +0900
--- work/src/backend/catalog/dependency.c	2010-01-18 14:38:33.972469881 +0900
***************
*** 42,47 ****
--- 42,48 ----
  #include "catalog/pg_opclass.h"
  #include "catalog/pg_operator.h"
  #include "catalog/pg_opfamily.h"
+ #include "catalog/pg_partition.h"
  #include "catalog/pg_proc.h"
  #include "catalog/pg_rewrite.h"
  #include "catalog/pg_tablespace.h"
*************** static const Oid object_classes[MAX_OCLA
*** 151,157 ****
  	ForeignDataWrapperRelationId,	/* OCLASS_FDW */
  	ForeignServerRelationId,	/* OCLASS_FOREIGN_SERVER */
  	UserMappingRelationId,		/* OCLASS_USER_MAPPING */
! 	DefaultAclRelationId		/* OCLASS_DEFACL */
  };
  
  
--- 152,159 ----
  	ForeignDataWrapperRelationId,	/* OCLASS_FDW */
  	ForeignServerRelationId,	/* OCLASS_FOREIGN_SERVER */
  	UserMappingRelationId,		/* OCLASS_USER_MAPPING */
! 	DefaultAclRelationId,		/* OCLASS_DEFACL */
! 	PartitionRelationId			/* OCLASS_PARTITION */
  };
  
  
*************** doDeletion(const ObjectAddress *object)
*** 1149,1154 ****
--- 1151,1160 ----
  			RemoveDefaultACLById(object->objectId);
  			break;
  
+ 		case OCLASS_PARTITION:
+ 			RemovePartition(object->objectId);
+ 			break;
+ 
  		default:
  			elog(ERROR, "unrecognized object class: %u",
  				 object->classId);
*************** getObjectClass(const ObjectAddress *obje
*** 2076,2081 ****
--- 2082,2091 ----
  		case DefaultAclRelationId:
  			Assert(object->objectSubId == 0);
  			return OCLASS_DEFACL;
+ 
+ 		case PartitionRelationId:
+ 			Assert(object->objectSubId == 0);
+ 			return OCLASS_PARTITION;
  	}
  
  	/* shouldn't get here */
*************** getObjectDescription(const ObjectAddress
*** 2685,2690 ****
--- 2695,2744 ----
  				break;
  			}
  
+ 		case OCLASS_PARTITION:
+ 			{
+ 				Relation	rel;
+ 				ScanKeyData skey[1];
+ 				SysScanDesc rcscan;
+ 				HeapTuple	tup;
+ 				Form_pg_partition partition;
+ 
+ 				rel = heap_open(PartitionRelationId, AccessShareLock);
+ 
+ 				ScanKeyInit(&skey[0],
+ 							Anum_pg_partition_partrelid,
+ 							BTEqualStrategyNumber, F_OIDEQ,
+ 							ObjectIdGetDatum(object->objectId));
+ 
+ 				rcscan = systable_beginscan(rel, PartitionRelidIndexId,
+ 											true, SnapshotNow, 1, skey);
+ 
+ 				tup = systable_getnext(rcscan);
+ 
+ 				if (!HeapTupleIsValid(tup))
+ 					elog(ERROR, "could not find tuple for partition %u",
+ 						 object->objectId);
+ 
+ 				partition = (Form_pg_partition) GETSTRUCT(tup);
+ 
+ 				switch (partition->partkind)
+ 				{
+ 					case PARTITION_BY_RANGE:
+ 						appendStringInfo(&buffer, _("range partition"));
+ 						break;
+ 					case PARTITION_BY_LIST:
+ 						appendStringInfo(&buffer, _("list partition"));
+ 						break;
+ 					default:
+ 						appendStringInfo(&buffer, _("partition"));
+ 						break;
+ 				}
+ 
+ 				systable_endscan(rcscan);
+ 				heap_close(rel, AccessShareLock);
+ 				break;
+ 			}
+ 
  		default:
  			appendStringInfo(&buffer, "unrecognized object %u %u %d",
  							 object->classId,
diff -cprN head/src/backend/catalog/heap.c work/src/backend/catalog/heap.c
*** head/src/backend/catalog/heap.c	2010-01-06 14:42:58.290140000 +0900
--- work/src/backend/catalog/heap.c	2010-01-18 14:38:33.973063002 +0900
***************
*** 43,48 ****
--- 43,49 ----
  #include "catalog/pg_constraint.h"
  #include "catalog/pg_inherits.h"
  #include "catalog/pg_namespace.h"
+ #include "catalog/pg_partition.h"
  #include "catalog/pg_statistic.h"
  #include "catalog/pg_tablespace.h"
  #include "catalog/pg_type.h"
*************** static void StoreConstraints(Relation re
*** 91,99 ****
  static bool MergeWithExistingConstraint(Relation rel, char *ccname, Node *expr,
  							bool allow_merge, bool is_local);
  static void SetRelationNumChecks(Relation rel, int numchecks);
- static Node *cookConstraint(ParseState *pstate,
- 			   Node *raw_constraint,
- 			   char *relname);
  static List *insert_ordered_unique_oid(List *list, Oid datum);
  
  Oid binary_upgrade_next_heap_relfilenode = InvalidOid;
--- 92,97 ----
*************** cookDefault(ParseState *pstate,
*** 2283,2289 ****
   * Parse state must be set up to recognize any vars that might appear
   * in the expression.
   */
! static Node *
  cookConstraint(ParseState *pstate,
  			   Node *raw_constraint,
  			   char *relname)
--- 2281,2287 ----
   * Parse state must be set up to recognize any vars that might appear
   * in the expression.
   */
! Node *
  cookConstraint(ParseState *pstate,
  			   Node *raw_constraint,
  			   char *relname)
*************** RemoveStatistics(Oid relid, AttrNumber a
*** 2376,2381 ****
--- 2374,2444 ----
  
  
  /*
+  * Remove a pg_partition entry
+  */
+ void
+ RemovePartition(Oid relid)
+ {
+ 	Relation		rel;
+ 	HeapScanDesc	scan;
+ 	ScanKeyData		key;
+ 	HeapTuple		tup;
+ 
+ 	/* DELETE FROM pg_partition WHERE partrelid = :relid */
+ 	rel = heap_open(PartitionRelationId, RowExclusiveLock);
+ 	tup = SearchSysCache(PARTITIONKEY,
+ 						 ObjectIdGetDatum(relid),
+ 						 0, 0, 0);
+ 	if (!HeapTupleIsValid(tup))
+ 		elog(ERROR, "cache lookup failed for partition %u", relid);
+ 	simple_heap_delete(rel, &tup->t_self);
+ 	ReleaseSysCache(tup);
+ 	heap_close(rel, RowExclusiveLock);
+ 
+ 	/* UPDATE pg_inherits SET inhvalues = NULL WHERE inhparent = :relid */
+ 	rel = heap_open(InheritsRelationId, RowExclusiveLock);
+ 	ScanKeyInit(&key,
+ 				Anum_pg_inherits_inhparent,
+ 				BTEqualStrategyNumber, F_OIDEQ,
+ 				ObjectIdGetDatum(relid));
+ 	scan = heap_beginscan(rel, SnapshotNow, 1, &key);
+ 
+ 	while (HeapTupleIsValid(tup = heap_getnext(scan, ForwardScanDirection)))
+ 	{
+ 		Datum	datum;
+ 		bool	isnull;
+ 
+ 		datum = heap_getattr(tup, Anum_pg_inherits_inhvalues,
+ 						 RelationGetDescr(rel), &isnull);
+ 		if (!isnull)
+ 		{
+ 			Datum		values[Natts_pg_inherits];
+ 			bool		nulls[Natts_pg_inherits];
+ 			bool		replaces[Natts_pg_inherits];
+ 			HeapTuple	newtup;
+ 
+ 			MemSet(values, 0, sizeof(values));
+ 			MemSet(nulls, false, sizeof(nulls));
+ 			MemSet(replaces, false, sizeof(replaces));
+ 
+ 			nulls[Anum_pg_inherits_inhvalues - 1] = true;
+ 			replaces[Anum_pg_inherits_inhvalues - 1] = true;
+ 
+ 			newtup = heap_modify_tuple(tup, RelationGetDescr(rel),
+ 										values, nulls, replaces);
+ 			simple_heap_update(rel, &newtup->t_self, newtup);
+ 			CatalogUpdateIndexes(rel, newtup);
+ 
+ 			heap_freetuple(newtup);
+ 		}
+ 	}
+ 	heap_endscan(scan);
+ 
+ 	heap_close(rel, RowExclusiveLock);
+ }
+ 
+ 
+ /*
   * RelationTruncateIndexes - truncate all indexes associated
   * with the heap relation to zero tuples.
   *
diff -cprN head/src/backend/catalog/pg_inherits.c work/src/backend/catalog/pg_inherits.c
*** head/src/backend/catalog/pg_inherits.c	2010-01-04 09:10:26.638773000 +0900
--- work/src/backend/catalog/pg_inherits.c	2010-01-18 14:38:33.974031974 +0900
***************
*** 21,37 ****
--- 21,46 ----
  
  #include "access/genam.h"
  #include "access/heapam.h"
+ #include "access/nbtree.h"
  #include "catalog/indexing.h"
  #include "catalog/pg_class.h"
  #include "catalog/pg_inherits.h"
  #include "catalog/pg_inherits_fn.h"
+ #include "catalog/pg_opclass.h"
+ #include "catalog/pg_partition.h"
+ #include "nodes/nodeFuncs.h"
  #include "parser/parse_type.h"
  #include "storage/lmgr.h"
+ #include "utils/array.h"
+ #include "utils/builtins.h"
+ #include "utils/datum.h"
  #include "utils/fmgroids.h"
+ #include "utils/lsyscache.h"
  #include "utils/syscache.h"
  #include "utils/tqual.h"
  
  static int	oid_cmp(const void *p1, const void *p2);
+ static int	partition_cmp(const void *a, const void *b, void *arg);
  
  
  /*
*************** oid_cmp(const void *p1, const void *p2)
*** 341,343 ****
--- 350,513 ----
  		return 1;
  	return 0;
  }
+ 
+ 
+ /*
+  * get_partitions - Gather information of a partition.
+  *
+  * Returns a list of Partition.
+  */
+ List *
+ get_partitions(Oid parentrelId, char *kind, Node **key, Oid *opclass)
+ {
+ 	Relation		inhrel;
+ 	SysScanDesc		scan;
+ 	ScanKeyData		skey[1];
+ 	HeapTuple		tp;
+ 	Datum			datum;
+ 	bool			isnull;
+ 	List		   *partitions = NIL;
+ 	Form_pg_opclass	form;
+ 	Oid				opfamily;
+ 	Oid				opcintype;
+ 	Oid				typid;
+ 	int16			typlen;
+ 	bool			typbyval;
+ 	char			typalign;
+ 	int				i,
+ 					n;
+ 
+ 	*kind = 0;
+ 	*key = NULL;
+ 	*opclass = InvalidOid;
+ 
+ 	/* Get partition key and operator. */
+ 	tp = SearchSysCache(PARTITIONKEY, ObjectIdGetDatum(parentrelId), 0, 0, 0);
+ 	if (!HeapTupleIsValid(tp))
+ 		return NIL;	/* not partitioned */
+ 
+ 	*kind = DatumGetChar(SysCacheGetAttr(PARTITIONKEY, tp,
+ 							Anum_pg_partition_partkind, &isnull));
+ 	*key = stringToNode(TextDatumGetCString(SysCacheGetAttr(
+ 					PARTITIONKEY, tp, Anum_pg_partition_partkey, &isnull)));
+ 	*opclass = DatumGetObjectId(SysCacheGetAttr(PARTITIONKEY, tp,
+ 							Anum_pg_partition_partopclass, &isnull));
+ 	ReleaseSysCache(tp);
+ 
+ 	tp = SearchSysCache(CLAOID, ObjectIdGetDatum(*opclass), 0, 0, 0);
+ 	if (!HeapTupleIsValid(tp))
+ 		elog(ERROR, "cache lookup failed for opclass %u", *opclass);
+ 	form = (Form_pg_opclass) GETSTRUCT(tp);
+ 	opfamily = form->opcfamily;
+ 	opcintype = form->opcintype;
+ 	ReleaseSysCache(tp);
+ 
+ 	typid = exprType(*key);
+ 	get_typlenbyvalalign(typid, &typlen, &typbyval, &typalign);
+ 
+ 	if (!has_subclass(parentrelId))
+ 		return NIL;	/* has no partitions */
+ 
+ 	/* Gather values from existing partition. */
+ 	inhrel = heap_open(InheritsRelationId, AccessShareLock);
+ 	ScanKeyInit(&skey[0],
+ 				Anum_pg_inherits_inhparent,
+ 				BTEqualStrategyNumber, F_OIDEQ,
+ 				ObjectIdGetDatum(parentrelId));
+ 	scan = systable_beginscan(inhrel, InheritsParentIndexId, true,
+ 							  SnapshotNow, 1, skey);
+ 
+ 	while ((tp = systable_getnext(scan)) != NULL)
+ 	{
+ 		Form_pg_inherits	inh = (Form_pg_inherits) GETSTRUCT(tp);
+ 		Partition	   *p;
+ 
+ 		datum = heap_getattr(tp, Anum_pg_inherits_inhvalues,
+ 						 RelationGetDescr(inhrel), &isnull);
+ 		if (isnull)
+ 			continue;	/* non-partition inheritance */
+ 
+ 		p = (Partition *) palloc(sizeof(Partition));
+ 		p->relid = inh->inhrelid;
+ 		deconstruct_array(DatumGetArrayTypeP(datum), typid, typlen,
+ 						typbyval, typalign, &p->values, NULL, &p->nvalues);
+ 
+ 		/* copy array elements if passed-by-reference */
+ 		if (!typbyval)
+ 		{
+ 			for (i = 0; i < p->nvalues; i++)
+ 			{
+ 				p->values[i] = (typlen == -1
+ 					? PointerGetDatum(PG_DETOAST_DATUM_COPY(p->values[i]))
+ 					: datumCopy(p->values[i], false, typlen));
+ 			}
+ 		}
+ 
+ 		partitions = lappend(partitions, p);
+ 	}
+ 
+ 	systable_endscan(scan);
+ 	heap_close(inhrel, AccessShareLock);
+ 
+ 	/*
+ 	 * Sort partitions compared with each first value. They are the upper range
+ 	 * of the partition for range partitions. List partitions don't always need
+ 	 * to sort whole of the list, but overflow partitions should be placed at
+ 	 * end of the list.
+ 	 */
+ 	n = list_length(partitions);
+ 	if (n >= 2)
+ 	{
+ 		Oid			cmptype = (opcintype != InvalidOid ? opcintype : typid);
+ 		Oid			cmpid;
+ 		FmgrInfo	cmpfn;
+ 		Partition **sorted;
+ 		ListCell   *cell;
+ 
+ 		cmpid = get_opfamily_proc(opfamily, cmptype, cmptype, BTORDER_PROC);
+ 		if (!OidIsValid(cmpid))
+ 			elog(ERROR, "missing support function %d(%u,%u) in opfamily %u",
+ 				 BTORDER_PROC, cmptype, cmptype, opfamily);
+ 		fmgr_info(cmpid, &cmpfn);
+ 
+ 		/*
+ 		 * We flatten list to array, sort items in array, and rebuild a list.
+ 		 */
+ 		sorted = (Partition **) palloc(sizeof(Partition *) * n);
+ 		i = 0;
+ 		foreach(cell, partitions)
+ 			sorted[i++] = (Partition *) lfirst(cell);
+ 		list_free(partitions);
+ 
+ 		qsort_arg(sorted, n, sizeof(Partition *), partition_cmp, &cmpfn);
+ 
+ 		partitions = NIL;
+ 		for (i = 0; i < n; i++)
+ 			partitions = lappend(partitions, sorted[i]);
+ 		pfree(sorted);
+ 	}
+ 
+ 	return partitions;
+ }
+ 
+ 
+ /*
+  * qsort function to compare partitions with the first value. Overflow
+  * partitions are always larger than normal partitions.
+  */
+ static int
+ partition_cmp(const void *a, const void *b, void *arg)
+ {
+ 	const Partition *lhs = *(const Partition **) a;
+ 	const Partition *rhs = *(const Partition **) b;
+ 	FmgrInfo *cmpfn = (FmgrInfo *) arg;
+ 
+ 	if (lhs->nvalues == 0 && rhs->nvalues == 0)
+ 		return 0;	/* should not ocuur */
+ 	else if (rhs->nvalues == 0)
+ 		return -1;	/* rhs is an overflow partition */
+ 	else if (lhs->nvalues == 0)
+ 		return +1;	/* lhs is an overflow partition */
+ 
+ 	return DatumGetInt32(FunctionCall2(cmpfn, lhs->values[0], rhs->values[0]));
+ }
diff -cprN head/src/backend/commands/indexcmds.c work/src/backend/commands/indexcmds.c
*** head/src/backend/commands/indexcmds.c	2010-01-04 09:10:26.638773000 +0900
--- work/src/backend/commands/indexcmds.c	2010-01-18 14:38:33.974031974 +0900
*************** static void ComputeIndexAttrs(IndexInfo 
*** 65,72 ****
  				  char *accessMethodName, Oid accessMethodId,
  				  bool amcanorder,
  				  bool isconstraint);
- static Oid GetIndexOpClass(List *opclass, Oid attrType,
- 				char *accessMethodName, Oid accessMethodId);
  static char *ChooseIndexNameAddition(List *colnames);
  static bool relationHasPrimaryKey(Relation rel);
  
--- 65,70 ----
*************** ComputeIndexAttrs(IndexInfo *indexInfo,
*** 1044,1052 ****
  /*
   * Resolve possibly-defaulted operator class specification
   */
! static Oid
  GetIndexOpClass(List *opclass, Oid attrType,
! 				char *accessMethodName, Oid accessMethodId)
  {
  	char	   *schemaname;
  	char	   *opcname;
--- 1042,1050 ----
  /*
   * Resolve possibly-defaulted operator class specification
   */
! Oid
  GetIndexOpClass(List *opclass, Oid attrType,
! 				const char *accessMethodName, Oid accessMethodId)
  {
  	char	   *schemaname;
  	char	   *opcname;
